/*RUN*/

"/home/rob/gtr/motherPatterns.scd".load;

MIDIClient.init;

~m32_1 = MIDIOut.newByName("MidiSport 4x4", "MidiSport 4x4 MIDI 1").latency_(Server.default.latency);

~m32_2 = MIDIOut.newByName("MidiSport 4x4", "MidiSport 4x4 MIDI 2").latency_(Server.default.latency);

//  setup of mother 32 noteon events

Pdef(\m_1,  Pbind( \type, \midi, \midicmd, \noteOn, \midiout, ~m32_1)).play(quant: 4);
Pdef(\m_2,  Pbind( \type, \midi, \midicmd, \noteOn, \midiout, ~m32_2)).play(quant: 4);

// CC Control Message 1 --->  TOP Mother32 ASSIGN OUT
( Pdef(\m_1_CC,  Pbind( \type, \midi, \midicmd, \control, \midiout, ~m32_1,
	\ctlNum, 1, \control, Pexprand(72,127, inf), \dur, ~r1)).play(quant:4));

// CC Control Message 1 --->  BOTTOM Mother32 ASSIGN OUT
Pdef(\m_2_CC,  Pbind( \type, \midi, \midicmd, \control, \midiout, ~m32_2, \ctlNum, 1, \control, Pexprand(77,127, inf), \dur, 1/8 )).play(quant:4);


