
//// MINIMAL BAROQUE GROOVE

~r0 = Pn(1/8, 16);

TempoClock.default.tempo = 60/60;

~rx0 = Pwrand([1/8, 1/4, 1/2, 4],[80,50,20,20].normalizeSum, 1);
~rx1 = Pwrand([1/8, 1/4, 1/2, 1],[80,50,20,20].normalizeSum, 1);
~rx2 = Pwrand([1/8, 1/4, 1/2],[80,50,20].normalizeSum, 1);
~rx3 = Pwrand([1/8, 1/4],[90,30].normalizeSum, 1);

~rs = Pseq([
/*	Pconst(32, Pseq([~rx0],inf)),
	Pconst(32, Pseq([~r3],inf)),
	Pconst(32, Pseq([~r3],inf)),
	Pconst(32, Pseq([~r04],inf)),*/
	Pconst(64, Pseq([~r0],inf)),

	/*Pconst(32, Pseq([~rx0],inf)),

	Pseq([~rx2],32),
	Pseq([~rx3],32),

	Pseq([~r03],8),
	Pseq([~r04],8),
	Pseq([~r0],8),
	Pseq([~r0],8),
	Pseq([~r04],8),
	//Pseq([~r16],8),
	Pseq([~r0],inf),*/
],1);

~rb = Pseq([
/*	Pconst(32, Pseq([~rx0],inf)),
	Pconst(32, Pseq([~r0],inf)),
	Pconst(32, Pseq([~r04],inf)),
	Pconst(32, Pseq([~r03],inf)),*/
	Pconst(64, Pseq([~r0],inf)),

	//
	// Pseq([~rx0],32),
	// Pseq([~rx1],32),
	// Pseq([~rx2],32),
	// Pseq([~rx3],32),
	//
	// Pseq([~r03],8),
	// Pseq([~r04],8),
	// Pseq([~r0],8),
	// Pseq([~r0],8),
	// Pseq([~r04],8),
	// //Pseq([~r16],8),
	// Pseq([~r0],inf),
],1);

Pbindef(\m_1, \scale,~s0,\degree,~ddd,\octave, ~o3,\dur,~rs );
Pbindef(\m_2, \scale,~s0,\degree,~ddd,\octave, ~o1,\dur,~rb );

Pdef(\m_1).play(quant: 4);    // TOP MOTHER
Pdef(\m_2).play(quant: 4);    // BTM MOTHER NOTEON

// CC Control Message 1 --->  TOP Mother32 ASSIGN OUT
( Pdef(\m_1_CC,  Pbind( \type, \midi, \midicmd, \control, \midiout, ~m32_1,
	\ctlNum, 1, \control, Pexprand(50,127, inf),\dur, 1/16)).play(quant:4));

// CC Control Message 1 --->  BOTTOM Mother32 ASSIGN OUT
Pdef(\m_2_CC,  Pbind( \type, \midi, \midicmd, \control, \midiout, ~m32_2, \ctlNum, 1, \control, Pexprand(77,127, inf), \dur, 1/8 )).play(quant:4);
